#include "lib/Compatibility.frag"

#define USE_TEXTURE_COORDS
#define USE_OBJECT_ID
#include "lib/Inputs.frag"

#define TEXTURED
#include "lib/Textures.frag"

#define ALPHA
#define ALPHA_MASKED
#include "lib/Materials.frag"

struct Material {
    /* GLSL doesn't allow empty structs. Variables starting with 'dummy' are
     * ignored by the material parser, so the UBO size is still minimal. */
    lowp float dummy;
};

void main() {
    alphaMask(fragObjectId, fragTextureCoords);

    /* Assign outColor such that the output does not get
     * optimized away, as rendering to color attachment without
     * output is invalid on WebGL */
    outColor = vec4(0.0, 0.0, 0.0, 1.0);
}
