uniform lowp uint numPointLights;
uniform lowp uint numSunLights;
uniform highp vec3 lightPositionsWorld[NUM_LIGHTS];
uniform lowp vec4 lightColors[NUM_LIGHTS];

mediump float phongDiffuseBrdf(mediump vec3 lightDir, mediump vec3 normal) {
    return max(0.0, dot(lightDir, normal));
}

mediump float phongSpecularBrdf(mediump vec3 lightDir, mediump vec3 normal, mediump vec3 viewDir, mediump float shininess) {
    mediump vec3 reflection = reflect(lightDir, normal);
    return pow(max(dot(viewDir, reflection), 0.0), shininess);
}
